import 'dart:convert';

import 'package:indigitall_flutter_plugin/core/callbacks/BaseCallback.dart';


class CoreResponse {
  static final String TAG = "[IND]api.Response";

  static const String _RESPONSE_STATUS_CODE = "statusCode";
  static const String _RESPONSE_MESSAGE = "message";
  static const String _RESPONSE_DATA = "data";

  // late BuildContext context;
  BaseCallback? callback;

  late int statusCode;
  late String message;
  dynamic data;

   CoreResponse(BaseCallback? callback) {
    // this.context = context;
    this.callback = callback;
  }

  void processData(int responseCode, String responseMessage, String jsonString) {
    this.statusCode = responseCode;
    this.message = responseMessage;
    this.data = "";
    try {
      if (jsonString != null){
        Map responseJson = jsonDecode(jsonString);
        responseJson.forEach((key,value){
          switch (key) {
            case _RESPONSE_STATUS_CODE:
              {
                this.statusCode = value;
              }
              break;
            case _RESPONSE_MESSAGE:
              {
                this.message = value;
              }
              break;
            case _RESPONSE_DATA:
              {
                dynamic obj = value;
                if (obj is List) {
                  this.data = responseJson;
                } else {
                  this.data = obj;
                }
              }
              break;
          }
        });
      }
    }on Exception catch (exception){
      print(exception.toString());
    }
  }
}