
// import 'package:shared_preferences/shared_preferences.dart';

import 'Validations.dart';

class PreferenceUtils {
  static const String _PREFS_NAME = "com.indigitall.prefs";

  static const String _PREFS_API_URL = _PREFS_NAME + ".apiURL";
  static const String _PREFS_APP_KEY = _PREFS_NAME + ".appKey";
  static const String _PREFS_SENDER_ID = _PREFS_NAME + ".senderId";
  static const String _PREFS_DEVICE_ID = _PREFS_NAME + ".deviceId";

  static const String _PREFS_INAPP_API_URL = _PREFS_NAME + ".InAppApiURL";
  static const String _PREFS_INAPP_ENABLED = _PREFS_NAME + ".inAppEnabled";

  // static SharedPreferences? _prefs;
  static dynamic _prefs;
  // Preferences bool methods

  static Future<bool> getbool(String key) async{
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null && _prefs!.getBool(key) != null) {
      return _prefs!.getBool(key)!;
    }
    return false;
  }

  static void setbool(String key, bool value) async {
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null){
      _prefs!.setBool(key, value);
    }
  }

  // Preferences Int methods

  static Future<int> getInt(String key) async {
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null && _prefs!.getInt(key) != null) {
      return _prefs!.getInt(key)!;
    }
    return 0;
  }

  static void setInt(String key, int value) async {
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null) _prefs!.setInt(key, value);
  }

  //Preferences Double methods

  static Future<double> getDouble(String key) async {
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null && _prefs!.getDouble(key) != null) {
      return _prefs!.getDouble(key)!;
    }
    return 0;
  }

  static void setDouble(String key, double value) async {
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null) _prefs!.setDouble(key, value);
  }

  // Preferences String methods

  static Future<String> getString(String key) async{
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null && _prefs!.getString(key) != null) {
      return _prefs!.getString(key)!;
    }
    return "";
  }

  static void setString(String key, String value) async{
    // _prefs = await SharedPreferences.getInstance();
    if (_prefs != null) _prefs!.setString(key, value);
  }

  static Future<String> getApiURL() {
    return getString(_PREFS_API_URL);
  }

  static void setApiURL(String value) {
    setString(_PREFS_API_URL, value);
  }

  // application preferences

  static Future<String> getAppKey() {
    return getString(_PREFS_APP_KEY);
  }

  static void setAppKey(String value) {
    setString(_PREFS_APP_KEY, value);
  }

  static Future<String> getSenderId() {
    return getString(_PREFS_SENDER_ID);
  }

  static void setSenderId(String value) {
    setString(_PREFS_SENDER_ID, value);
  }

  static Future<String> getDeviceId() {
    return getString(_PREFS_DEVICE_ID);
  }

  static void setDeviceId(String value) {
    if (Validations.isDeviceIdCorrectFormat(value)) {
      setString(_PREFS_DEVICE_ID, value);
    }
  }

  static Future<bool> getInappEnabled() {
    return getbool(_PREFS_INAPP_ENABLED);
  }

  static void setInappEnabled(bool value) {
    setbool(_PREFS_INAPP_ENABLED, value);
  }

  static void setInAppApiURL(String value) {
    setString(_PREFS_INAPP_API_URL, value);
  }

  static Future<String> getInAppApiURL() {
    return getString(_PREFS_INAPP_API_URL);
  }

}