import 'package:indigitall_flutter_plugin/core/api/CoreClient.dart';
import 'package:indigitall_flutter_plugin/core/utils/PreferenceUtils.dart';
import 'package:indigitall_flutter_plugin/inapp/api/requests/CampaignInAppRequest.dart';
import 'package:indigitall_flutter_plugin/inapp/api/responses/InAppResponse.dart';

class InAppClient extends CoreClient {
  static const String TAG = "[IND]InAppApi.Client";

  static const String URL_INAPP_BASE = "https://inapp-api.indigitall.com/v1";

  static const String ENDPOINT_EVENT_INAPP = "/event/inApp";

  static const String ENDPOINT_CAMPAIGN_INAPP = "/campaign/{tag}";

  static Future<String> getApiURL() async {
    String url = "";
    url = await PreferenceUtils.getInAppApiURL();
    if (url != "" && "/" == url.substring(url.length - 1)) {
        url = url.substring(0, url.length - 1);
    }else{
      url = URL_INAPP_BASE;
    }
    return url;
  }
  //
  // static Future<void> getInAppCampaign(CampaignInAppRequest request, InAppCallback callback) async {
  //   await CoreClient.get(await getApiURL() + ENDPOINT_CAMPAIGN_INAPP, await request.getCampaignInAppRequest(), InAppResponse(callback));
  // }
}